import * as React from 'react';

import { IgrDataGridModule, IgrTextColumn, IgrNumericColumn, IgrGridSortDescriptionsChangedEventArgs, HeaderClickAction } from 'igniteui-react-grids';
import { IgrDataGrid } from 'igniteui-react-grids';

IgrDataGridModule.register();

export default class DataGridOverview extends React.Component<any, any> {

    public data: any[];
    public grid: IgrDataGrid;

    constructor(props: any) {
        super(props);

        this.data = [
            { ID: 1, FamilyName: "田沢", GivenName: "泰三", Age: Math.floor(Math.random() * 61) + 20  },
            { ID: 2, FamilyName: "玉木", GivenName: "裕美子", Age: Math.floor(Math.random() * 61) + 20 },
            { ID: 3, FamilyName: "稲垣", GivenName: "幸男", Age: Math.floor(Math.random() * 61) + 20 },
            { ID: 4, FamilyName: "石橋", GivenName: "幸春", Age: Math.floor(Math.random() * 61) + 20 },
            { ID: 5, FamilyName: "小柳", GivenName: "穂香", Age: Math.floor(Math.random() * 61) + 20 },
        ];

        this.onGridRef = this.onGridRef.bind(this);
    }

    public render(): JSX.Element {
        return (
            <div style={{margin: "1em"}}>
                <IgrDataGrid
                    ref={this.onGridRef}
                    height="300px"
                    width="100%"
                    autoGenerateColumns="false"
                    dataSource={this.data}
                    headerClickAction={HeaderClickAction.None}>
                    <IgrTextColumn field="FamilyName" headerText="Family Name" />
                    <IgrTextColumn field="GivenName" headerText="Given Name" />
                    <IgrNumericColumn field="Age" headerText="Age" />
               </IgrDataGrid>
            </div>
        );
    }

    public onGridRef(grid: IgrDataGrid) {
        if (!grid) { return; }

        this.grid = grid;
    }
}